/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.common.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPAction;
import jp.mosp.common.bean.AuthBean;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.LogUtility;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dto.CmAspUserDto;
import jp.mosp.common.dto.HumanBasisDtoInterface;
import jp.mosp.common.part.MosPCodePart;
import jp.mosp.common.part.MosPMenuPart;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.part.HumanPart;
import jp.mosp.kintai.common.vo.MosPLoginVo;

/**
 * @author yoshida
 *
 */
public class MosPAuthAction extends MosPAction {
	
	/**
	 * コンストラクタ
	 */
	public MosPAuthAction() {
		super();
		setNeedSession(false);
		setNeedAspUser(false);
		setNeedUser(false);
		setCheckAuth(false);
		setCheckProcSeq(false);
	}
	
	public void action() throws Exception {
		// 初期処理 
		init();
		// 認証
		authentication();
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new MosPLoginVo(cfg, msg, nam, cmd, aspUser, user);
	}
	
	@Override
	protected void init() throws Exception {
		BaseVo vo = getSpecificVo();
		// VOの準備
		// VO初期化
		vo.initVo(cfg, msg, nam, cmd, aspUser, user);
		vo.clearMessage();
		vo.clearErrField();
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
	}
	
	/**
	 * 認証
	 * @throws Exception 	例外処理
	 */
	protected void authentication() throws Exception {
		// ASPユーザー取得(設定ファイルのASP設定で判断)
		setAspUser();
		// 認証処理
		login();
		// 入社日をチェックする。
		checkEmployDate();
		// 次のページへ遷移処理
		setNextPage();
		// ユーザー情報保存
		// セッションの再取得
		if (VariousUtil.isNotNull(session)) {
			session.invalidate();
		}
		session = request.getSession(true);
		// ユーザー情報を設定
		session.setAttribute(MospConst.ATT_ASPUSER, aspUser);
		session.setAttribute(MospConst.ATT_USER, user);
		request.setAttribute(MospConst.ATT_USER, user);
		// ログ出力
		LogUtility.log(request, 4, MospConst.LOG_MOSPINF, MospConst.LOG_MSG_LOGIN);
	}
	
	/**
	 * 認証処理
	 * @throws Exception 	例外処理
	 */
	protected void login() throws Exception {
		MosPLoginVo vo = (MosPLoginVo)getVo();
		// パラメータの取得
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DBコネクションの取得
		getConnection();
		// 認証処理
		AuthBean auth = new AuthBean(cfg, cmd, aspUser, conn, hasMospSeJar());
		auth.login(vo.getUserId(), vo.getPass());
		// 認証が失敗している場合
		if (auth.isErrMessage()) {
			// エラーメッセージの設定
			addErrMessage(getMessage(auth.getErrMessageCode(), ""));
			throw new MospException(auth.getMosPExceptionCode());
		}
		user = auth.getCmUserDto();
		// コミット
		commit();
	}
	
	/**
	 * 次ページ遷移処理
	 * @throws Exception	例外処理が発生した場合
	 */
	protected void setNextPage() throws Exception {
		MosPLoginVo vo = (MosPLoginVo)getVo();
		// 初期コマンド設定
		String nextCmd = "C1060";
		// パスワード有効期限確認
		boolean validPassWord = true;
		// Partクラスの準備
		// パスワード有効期限を過ぎていたら、パスワード変更画面に遷移する。
		// ユーザーIDとパスワードが同じ場合、パスワード変更画面に遷移する。
		MosPCodePart mospcode = (MosPCodePart)part().get(MosPCodePart.class);
		if (mospcode.isExpirePassWord(user.getChangePass())
				|| VariousUtil.isDefaultPassWord(user.getUserId(), vo.getPass())) {
			nextCmd = MospConst.CMD_PASS_FORCE;
			validPassWord = false;
		}
		// adminの場合CSSと初期コマンドを変更
		if (user.getAuthority().equals(CommonConst.AUTHORITY_ADMIN) && validPassWord) {
			user.setCommonCss(CommonConst.CSS_ADMIN);
			//nextCmd = vo.CMD_MENU_SYSTEM2;
			nextCmd = "S2910";
		}
		MosPMenuPart menu = (MosPMenuPart)part().get(MosPMenuPart.class);
		// 従業員権限のみの場合、当日の勤怠入力へ移動
		if (MosPMenuPart.isEmployeeUser(menu.getUserAuthInfo()) && validPassWord) {
			nextCmd = "K1014";
		}
		// 次ページコマンド
		setNextCmd(nextCmd);
		// サーブレットへ
		setUrl(MospConst.URL_SRV);
	}
	
	/**
	 * 入社日のチェック
	 * <p>	2009/06/18	m.yoshida	mosp-base対応	</p>
	 * @throws Exception	例外処理が発生した場合
	 */
	protected void checkEmployDate() throws Exception {
		// Partクラスの準備
		HumanPart human = (HumanPart)part().get(HumanPart.class);
		// 入社日以降しかログインできないようにする。
		HumanBasisDtoInterface dto = human.getBasisInfo(user.getKCode());
		Date entranceDate = null;
		if (VariousUtil.isNotNull(dto)) {
			entranceDate = DateUtil.convIntegerDateToDate(dto.getNyDate());
		}
		// 管理者権限の場合、人事基本情報は無い
		if (user.getAuthority().equals(CommonConst.AUTHORITY_ADMIN)) {
			entranceDate = new Date(0);
		}
		// 入社日が無いもしくは、入社日より前の場合、ログイン不可
		if (entranceDate == null || DateUtil.getSystemDate().compareTo(entranceDate) < 0) {
			// エラーメッセージの設定
			addErrMessage(getMessage(MospConst.MSG_AUTH_FAILED, ""));
			throw new MospException(MospConst.EX_AUTH_FAILED);
		}
	}
	
	/**
	 * ASPユーザー取得(設定ファイルのASP設定で判断)
	 * @throws Exception	例外処理が発生した場合
	 */
	protected void setAspUser() throws Exception {
		// ASPユーザー取得(設定ファイルのASP設定で判断)
		switch (MospUtility.getAspFlag(cfg)) {
			case 0:
				// 0：ASP(xユーザー:1アプリ)
			case 1:
				// 1：ASP(1ユーザー:1アプリ)
				// ASPユーザー情報をセット(セッションから取得)
				session = request.getSession(false);
				aspUser = (CmAspUserDto)session.getAttribute(MospConst.ATT_ASPUSER);
				BaseVo aspVo = (BaseVo)request.getAttribute(MospConst.ATT_VO);
				// returnUrl設定
				BaseVo vo = (BaseVo)getVo();
				vo.setRetUrl(aspVo.getRetUrl());
				break;
			case 2:
				// 2：非ASP
				// ASPユーザー情報をセット(ログイン画面でのセッション切断無視)
				createAspUser();
				break;
			default:
				throw new MospException(MospConst.EX_ASP_PROPERTIES);
		}
	}
	
}
